#include <iostream>
#define _USE_MATH_DEFINES
#include <math.h>

struct Position
{
  double x;
  double y;
};
struct WheelVelocity
{
  double v_l;
  double v_r;
};

WheelVelocity joystick(double k, Position pos)
{
  double th = atan2(pos.y, pos.x);
  double v = k * hypot(pos.x, pos.y);
  WheelVelocity wv;
  wv.v_l = v * cos(th - M_PI / 4.0);
  wv.v_r = v * sin(th - M_PI / 4.0);

  return wv;
}

int main(void)
{
  double k = 1.0;
  Position pos[] = {
    { 0.0, 1.0},
    { 1.0, 1.0},
    { 1.0, 0.0},
    { 0.0,-1.0},
    {-1.0,-1.0},
  };

  for (int i(0); i < 5; ++i)
    {
      WheelVelocity wv = joystick(k, pos[i]);
      std::cout << "pos (x, y): " << pos[i].x << ", " << pos[i].y << "\t ==> ";
      std::cout << "velocity (v_l, v_r): " << wv.v_l << ", " << wv.v_r << std::endl;
    }

  return 0;
}
